diff --git a/web/pgacloud/pgacloud.py b/web/pgacloud/pgacloud.py
index a0a1c32ba..2c5f964a4 100755
--- a/web/pgacloud/pgacloud.py
+++ b/web/pgacloud/pgacloud.py
@@ -40,8 +40,6 @@ def get_args(providers):
     """ Creates the parsers and returns the args """
     # Create the top-level parser
     parser = argparse.ArgumentParser(prog='pgacloud.py')
-    parser.add_argument('--debug', action=argparse.BooleanOptionalAction,
-                        default=True, help='send debug messages to stderr')
 
     # Create the provider sub-parser
     parsers = parser.add_subparsers(help='provider help', dest='provider')
diff --git a/web/pgacloud/providers/biganimal.py b/web/pgacloud/providers/biganimal.py
new file mode 100644
index 000000000..53b0789f2
--- /dev/null
+++ b/web/pgacloud/providers/biganimal.py
@@ -0,0 +1,181 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" EDB BigAnimal PostgreSQL provider """
+
+import os
+import time
+import requests
+import json
+
+from providers._abstract import AbsProvider
+from utils.io import debug, error, output
+
+
+class BigAnimalProvider(AbsProvider):
+    BASE_URL = 'https://portal.biganimal.com/api/v1'
+
+    def __init__(self):
+        self._clients = {}
+        self._access_key = None
+        self._database_pass = None
+        self._cluster_info = None
+
+        # Get the credentials
+        if 'BIGANIMAL_ACCESS_KEY' in os.environ:
+            self._access_key = os.environ['BIGANIMAL_ACCESS_KEY']
+        if 'BIGANIMAL_DATABASE_PASSWORD' in os.environ:
+            self._database_pass = os.environ['BIGANIMAL_DATABASE_PASSWORD']
+
+    def init_args(self, parsers):
+        """ Create the command line parser for this provider """
+        self.parser = parsers.add_parser('biganimal',
+                                         help='Amazon AWS RDS PostgreSQL',
+                                         epilog='...')
+
+        # Create the command sub-parser
+        parsers = self.parser.add_subparsers(help='BigAnimal commands',
+                                             dest='command')
+
+        # Create the create instance command parser
+        parser_create_instance = parsers.add_parser('create-instance',
+                                                    help='create a new '
+                                                         'instance')
+        parser_create_instance.add_argument('--region', required=True,
+                                            help='name of the region')
+        parser_create_instance.add_argument('--name', required=True,
+                                            help='name of the cluster')
+        parser_create_instance.add_argument('--db-type', required=True,
+                                            help='database type (PostgreSQL'
+                                                 ' or EPAS)')
+        parser_create_instance.add_argument('--db-version', required=True,
+                                            help='database version')
+        parser_create_instance.add_argument('--instance-type', required=True,
+                                            help='machine type for the '
+                                                 'instance nodes')
+        parser_create_instance.add_argument('--volume-type', required=True,
+                                            help='storage type for the data '
+                                                 'database')
+        parser_create_instance.add_argument('--volume-properties',
+                                            required=True,
+                                            help='storage properties')
+        parser_create_instance.add_argument('--private-network', required=True,
+                                            help='Private or Public Network')
+        parser_create_instance.add_argument('--public-ip', default='',
+                                            help='Public IP '
+                                                 '(default: 127.0.0.1)')
+
+    def cmd_create_instance(self, args):
+        """ Create a biganimal cluster """
+
+        try:
+            private_network = True if args.private_network == '1' else False
+            ip = args.public_ip if args.public_ip else '0.0.0.0/0'
+            IpRanges = []
+
+            ip = ip.split(',')
+            for i in ip:
+                IpRanges.append([i, 'pgcloud client {}'.format(i)])
+
+            debug('Creating BigAnimal cluster: {}...'.format(args.name))
+
+            _url = "{0}/{1}".format(self.BASE_URL, 'clusters')
+            _headers = {"content-type": "application/json",
+                        "accept": "application/json",
+                        'authorization': 'Bearer {0}'.format(self._access_key)}
+
+            _data = {
+                'clusterName': args.name,
+                'instanceTypeId': args.instance_type,
+                'password': self._database_pass,
+                'postgresTypeId': args.db_type,
+                'postgresVersion': args.db_version,
+                'privateNetworking': private_network,
+                'providerId': 'azure',
+                'regionId': args.region,
+                'replicas': 3,
+                'volumePropertiesId': args.volume_properties,
+                'volumeTypeId': args.volume_type,
+                'zoneRedundantHa': False,
+                'pgConfigMap': [],
+            }
+
+            if not private_network:
+                _data['allowIpRangeMap'] = IpRanges
+
+            cluster_resp = requests.post(_url,
+                                         headers=_headers,
+                                         data=json.dumps(_data))
+
+            if cluster_resp.status_code == 202 and cluster_resp.content:
+                cluster_info = json.loads(cluster_resp.content)
+                instance_id = cluster_info['pgId']
+                instance = self.get_instance_status(instance_id)
+                data = {'instance': {
+                    'ImageName': instance['imageName'],
+                    'Database Type': instance['pgType']['name'],
+                    'Hostname': instance['clusterConnectionInfo'][
+                        'serviceName'],
+                    'Port': instance['clusterConnectionInfo']['port'],
+                    'Database': instance['clusterConnectionInfo'][
+                        'databaseName'],
+                    'Username': instance['clusterConnectionInfo'][
+                        'username']
+                }}
+
+                output(data)
+            else:
+                error(str(cluster_resp.text))
+
+        except Exception as e:
+            debug(str(e))
+
+    def get_instance_status(self, instance_id):
+        """ Get the biganimal cluster status """
+
+        running = True
+        status = None
+        while running:
+            _url = "{0}/{1}/{2}".format(self.BASE_URL, 'clusters', instance_id)
+            _headers = {"accept": "application/json",
+                        'authorization': 'Bearer {0}'.format(self._access_key)}
+
+            cluster_resp = requests.get(_url,
+                                        headers=_headers)
+
+            if cluster_resp.status_code == 200 and cluster_resp.content:
+                cluster_info = json.loads(cluster_resp.content)
+
+                self._cluster_info = cluster_info[0]
+
+                if self._cluster_info['instance'] != 0 and\
+                    self._cluster_info['phase'] not in [
+                    'Cluster creation request received',
+                    'Setting up primary',
+                    'Creating CNP cluster'
+                ]:
+                    running = False
+
+                if status != self._cluster_info['phase']:
+                    status = self._cluster_info['phase']
+                    debug('BigAnimal cluster status: {}...'.format(
+                        status))
+            else:
+                running = False
+                error(str(cluster_resp.text))
+
+            if running:
+                time.sleep(5)
+
+        return self._cluster_info
+
+
+def load():
+    """ Loads the current provider """
+    return BigAnimalProvider()
diff --git a/web/pgacloud/providers/rds.py b/web/pgacloud/providers/rds.py
index 86dd4977b..7381917cc 100644
--- a/web/pgacloud/providers/rds.py
+++ b/web/pgacloud/providers/rds.py
@@ -144,7 +144,7 @@ class RdsProvider(AbsProvider):
             name = 'pgacloud_{}_{}_{}'.format(args.name,
                                               ip[0].replace('.', '-'),
                                               get_random_id())
-            debug(args, 'Creating security group: {}...'.format(name))
+            debug('Creating security group: {}...'.format(name))
             output({'Creating': 'Creating security group: {}...'.format(name)})
             response = ec2.create_security_group(
                 Description='Inbound access for {} to RDS instance {}'.format(
@@ -152,7 +152,7 @@ class RdsProvider(AbsProvider):
                 GroupName=name
             )
         except Exception as e:
-            error(args, str(e))
+            error(str(e))
 
         return response['GroupId']
 
@@ -172,8 +172,7 @@ class RdsProvider(AbsProvider):
             })
         try:
             output({'Adding': 'Adding ingress rule for: {}...'.format(ip)})
-            debug(args,
-                  'Adding ingress rule for: {}...'.format(ip))
+            debug('Adding ingress rule for: {}...'.format(ip))
             ec2.authorize_security_group_ingress(
                 GroupId=security_group,
                 IpPermissions=[
@@ -186,7 +185,7 @@ class RdsProvider(AbsProvider):
                 ]
             )
         except Exception as e:
-            error(args, e)
+            error(e)
 
     def _create_rds_instance(self, args, security_group):
         """ Create an RDS instance """
@@ -197,7 +196,7 @@ class RdsProvider(AbsProvider):
             else args.db_password
 
         try:
-            debug(args, 'Creating RDS instance: {}...'.format(args.name))
+            debug('Creating RDS instance: {}...'.format(args.name))
             rds.create_db_instance(DBInstanceIdentifier=args.name,
                                    AllocatedStorage=args.storage_size,
                                    DBName=args.db_name,
@@ -218,18 +217,18 @@ class RdsProvider(AbsProvider):
 
         except rds.exceptions.DBInstanceAlreadyExistsFault as e:
             try:
-                debug(args, DEL_SEC_GROUP_MSG.format(security_group))
+                debug(DEL_SEC_GROUP_MSG.format(security_group))
                 ec2.delete_security_group(GroupId=security_group)
             except Exception:
                 pass
-            error(args, 'RDS instance {} already exists.'.format(args.name))
+            error('RDS instance {} already exists.'.format(args.name))
         except Exception as e:
             try:
-                debug(args, DEL_SEC_GROUP_MSG.format(security_group))
+                debug(DEL_SEC_GROUP_MSG.format(security_group))
                 ec2.delete_security_group(GroupId=security_group)
             except Exception:
                 pass
-            error(args, str(e))
+            error(str(e))
 
         # Wait for completion
         running = True
@@ -252,7 +251,7 @@ class RdsProvider(AbsProvider):
         """ Delete an RDS instance """
         rds = self._get_aws_client('rds', args)
 
-        debug(args, 'Deleting RDS instance: {}...'.format(name))
+        debug('Deleting RDS instance: {}...'.format(name))
         try:
             rds.delete_db_instance(
                 DBInstanceIdentifier=name,
@@ -260,7 +259,7 @@ class RdsProvider(AbsProvider):
                 DeleteAutomatedBackups=True
             )
         except Exception as e:
-            error(args, str(e))
+            error(str(e))
 
         # Wait for completion
         while True:
@@ -269,7 +268,7 @@ class RdsProvider(AbsProvider):
             except rds.exceptions.DBInstanceNotFoundFault:
                 return
             except Exception as e:
-                error(args, str(e))
+                error(str(e))
 
             time.sleep(5)
 
@@ -277,13 +276,13 @@ class RdsProvider(AbsProvider):
         """ Delete a security group """
         ec2 = self._get_aws_client('ec2', args)
 
-        debug(args, 'Deleting security group: {}...'.format(id))
+        debug('Deleting security group: {}...'.format(id))
         try:
             ec2.delete_security_group(
                 GroupId=id
             )
         except Exception as e:
-            error(args, str(e))
+            error(str(e))
 
     ##########################################################################
     # User commands
diff --git a/web/pgacloud/utils/io.py b/web/pgacloud/utils/io.py
index e55834702..f3ba0db6d 100644
--- a/web/pgacloud/utils/io.py
+++ b/web/pgacloud/utils/io.py
@@ -13,20 +13,17 @@ import sys
 import time
 
 
-def debug(args, message):
+def debug(message):
     """ Print a debug message """
-    if not args.debug:
-        return
-
     now = datetime.datetime.now()
 
     print('[{}]: {}'.format(now.strftime("%H:%M:%S"), message),
-          file=sys.stderr, flush=True)
+          file=sys.stderr)
 
 
-def error(args, message):
+def error(message):
     """ Print an error message and exit """
-    debug(args, message)
+    debug(message)
 
     output({'error': message})
 
@@ -35,4 +32,4 @@ def error(args, message):
 
 def output(data):
     """ Dump JSON output from a dict """
-    print(json.dumps(data), flush=True)
+    print(json.dumps(data))
diff --git a/web/pgadmin/misc/bgprocess/process_executor.py b/web/pgadmin/misc/bgprocess/process_executor.py
index bdeffe34d..fe9adfa06 100755
--- a/web/pgadmin/misc/bgprocess/process_executor.py
+++ b/web/pgadmin/misc/bgprocess/process_executor.py
@@ -170,7 +170,8 @@ class ProcessLogger(Thread):
         Thread.__init__(self)
         self.process = None
         self.stream = None
-        self.logger = open(os.path.join(_out_dir, stream_type), 'wb')
+        self.logger = open(os.path.join(_out_dir, stream_type), 'wb',
+                           buffering=0)
 
     def attach_process_stream(self, process, stream):
         """
diff --git a/web/pgadmin/misc/cloud/__init__.py b/web/pgadmin/misc/cloud/__init__.py
index c03502813..603e98dba 100644
--- a/web/pgadmin/misc/cloud/__init__.py
+++ b/web/pgadmin/misc/cloud/__init__.py
@@ -10,8 +10,8 @@
 """Implements Cloud Deployment"""
 
 import simplejson as json
-from flask import Response, url_for, session
-from flask import render_template, request, current_app
+from flask import Response, url_for
+from flask import render_template, request
 from flask_babel import gettext
 from flask_security import login_required, current_user
 
@@ -20,18 +20,15 @@ from pgadmin.utils.ajax import make_json_response,\
     internal_server_error, bad_request, success_return
 
 from pgadmin.utils.constants import MIMETYPE_APP_JS
-from pgadmin.misc.bgprocess.processes import BatchProcess, IProcessDesc
 from pgadmin.model import db, Server, Process
-from pgadmin.misc.cloud.utils.rds import RDS, verify_aws_credentials,\
-    get_aws_db_instances, get_aws_db_versions, clear_aws_session,\
-    get_aws_regions
 from pgadmin.misc.cloud.utils import get_my_ip
 
-from config import root
+from pgadmin.misc.cloud.biganimal import deploy_on_biganimal,\
+    clear_biganimal_session
+from pgadmin.misc.cloud.rds import deploy_on_rds, clear_aws_session
 
 # set template path for sql scripts
 MODULE_NAME = 'cloud'
-server_info = {}
 
 
 class CloudModule(PgAdminModule):
@@ -42,7 +39,6 @@ class CloudModule(PgAdminModule):
         class and define methods to load its own
         javascript file.
 
-    LABEL = gettext('Browser')
     """
 
     def get_own_stylesheets(self):
@@ -77,12 +73,8 @@ class CloudModule(PgAdminModule):
             list: URL endpoints for cloud module
         """
         return ['cloud.deploy_on_cloud',
-                'cloud.get_aws_db_versions',
-                'cloud.verify_credentials',
-                'cloud.get_aws_db_instances',
                 'cloud.update_cloud_server',
                 'cloud.update_cloud_process',
-                'cloud.get_aws_regions',
                 'cloud.get_host_ip']
 
 
@@ -114,172 +106,46 @@ def script():
                  methods=['GET'], endpoint='get_host_ip')
 @login_required
 def get_host_ip():
-    """test"""
+    """Get host IP Address"""
     ip = get_my_ip()
     return make_json_response(data=ip)
 
 
-@blueprint.route('/verify_credentials/',
-                 methods=['POST'], endpoint='verify_credentials')
-@login_required
-def verify_credentials():
-    """Verify Credentials."""
-    data = json.loads(request.data, encoding='utf-8')
-
-    status, msg = verify_aws_credentials(data)
-    if status:
-        msg = 'verified'
-
-    return make_json_response(success=status, info=msg)
-
-
-@blueprint.route('/get_aws_db_instances/',
-                 methods=['GET'], endpoint='get_aws_db_instances')
-@login_required
-def get_db_instances():
-    """
-    Fetch AWS DB Instances based on engine version.
-    """
-    # Get Engine Version
-    eng_version = request.args.get('eng_version')
-    status, versions = get_aws_db_instances(eng_version)
-
-    if not status:
-        return make_json_response(
-            status=410,
-            success=0,
-            errormsg=versions
-        )
-
-    return make_json_response(data=versions)
-
-
-@blueprint.route('/get_aws_db_versions/',
-                 methods=['GET', 'POST'], endpoint='get_aws_db_versions')
-@login_required
-def get_db_versions():
-    """GET AWS Database Versions for AWS."""
-    status, versions = get_aws_db_versions()
-    if not status:
-        return make_json_response(
-            status=410,
-            success=0,
-            errormsg=str(versions)
-        )
-    return make_json_response(data=versions)
-
-
-@blueprint.route('/get_aws_regions/',
-                 methods=['GET', 'POST'], endpoint='get_aws_regions')
-@login_required
-def get_db_versions():
-    """GET AWS Regions for AWS."""
-    status, regions = get_aws_regions()
-    if not status:
-        return make_json_response(
-            status=410,
-            success=0,
-            errormsg=str(regions)
-        )
-    return make_json_response(data=regions)
-
-
 @blueprint.route(
     '/deploy', methods=['POST'], endpoint='deploy_on_cloud'
 )
 @login_required
 def deploy_on_cloud():
-    """Deploy on Cloud"""
+    """Deploy on Cloud."""
 
     data = json.loads(request.data, encoding='utf-8')
-    from subprocess import Popen, PIPE
-    _cmd = 'python'
-    _cmd_script = '{0}/pgacloud/pgacloud.py'.format(root)
-
-    args = [_cmd_script,
-            '--debug',
-            data['cloud'],
-            '--region',
-            str(data['secret']['aws_region']),
-            'create-instance',
-            '--name',
-            data['instance_details']['aws_name'],
-            '--db-name',
-            data['db_details']['aws_db_name'],
-            '--db-username',
-            data['db_details']['aws_db_username'],
-            '--db-port',
-            str(data['db_details']['aws_db_port']),
-            '--db-version',
-            str(data['instance_details']['aws_db_version']),
-            '--instance-type',
-            data['instance_details']['aws_instance_type'],
-            '--storage-type',
-            data['instance_details']['aws_storage_type'],
-            '--storage-size',
-            str(data['instance_details']['aws_storage_size']),
-            '--public-ip',
-            str(data['instance_details']['aws_public_ip']),
-            ]
-
-    if data['instance_details']['aws_storage_type'] == 'io1':
-        args.append('--storage-iops')
-        args.append(str(data['instance_details']['aws_storage_IOPS']))
-
-    _cmd_msg = '{0} {1} {2}'.format(_cmd, _cmd_script, ' '.join(args))
-    try:
-        sid = _create_server({
-            'gid': data['db_details']['gid'],
-            'name': data['instance_details']['aws_name'],
-            'db': data['db_details']['aws_db_name'],
-            'username': data['db_details']['aws_db_username'],
-            'port': data['db_details']['aws_db_port'],
-            'cloud_status': -1
-        })
-
-        p = BatchProcess(
-            desc=CloudProcessDesc(sid, _cmd_msg, data['cloud'],
-                                  data['instance_details']['aws_name']),
-            cmd=_cmd,
-            args=args
-        )
-
-        env = dict()
-        env['AWS_ACCESS_KEY_ID'] = data['secret']['aws_access_key']
-        env['AWS_SECRET_ACCESS_KEY'] = data['secret']['aws_secret_access_key']
-
-        if 'aws_session_token' in data['secret'] and\
-                data['secret']['aws_session_token'] is not None:
-            env['AWS_SESSION_TOKEN'] = data['secret']['aws_session_token']
-
-        if 'aws_db_password' in data['db_details']:
-            env['AWS_DATABASE_PASSWORD'] = data[
-                'db_details']['aws_db_password']
-
-        p.set_env_variables(None, env=env)
-        p.update_server_id(p.id, sid)
-        p.start()
+    if data['cloud'] == 'rds':
+        status, resp = deploy_on_rds(data)
+    elif data['cloud'] == 'biganimal':
+        status, resp = deploy_on_biganimal(data)
+    else:
+        status = False
+        resp = gettext('No cloud implementation.')
 
-    except Exception as e:
-        current_app.logger.exception(e)
+    if not status:
         return make_json_response(
             status=410,
             success=0,
-            errormsg=str(e)
+            errormsg=resp
         )
 
     # Return response
     return make_json_response(
         success=1,
         data={'job_id': 1, 'node': {
-            '_id': sid,
+            '_id': resp['sid'],
             '_pid': data['db_details']['gid'],
             'connected': False,
             '_type': 'server',
             'icon': 'icon-server-cloud-deploy',
-            'id': 'server_{}'.format(sid),
+            'id': 'server_{}'.format(resp['sid']),
             'inode': True,
-            'label': data['instance_details']['aws_name'],
+            'label': resp['label'],
             'server_type': 'pg',
             'module': 'pgadmin.node.server',
             'cloud_status': -1
@@ -287,25 +153,6 @@ def deploy_on_cloud():
     )
 
 
-def _create_server(data):
-    """Create Server"""
-    server = Server(
-        user_id=current_user.id,
-        servergroup_id=data.get('gid'),
-        name=data.get('name'),
-        maintenance_db=data.get('db'),
-        username=data.get('username'),
-        ssl_mode='prefer',
-        cloud_status=data.get('cloud_status'),
-        connect_timeout=30,
-    )
-
-    db.session.add(server)
-    db.session.commit()
-
-    return server.id
-
-
 def update_server(data):
     """Update Server."""
     server_data = data
@@ -315,7 +162,7 @@ def update_server(data):
     ).first()
 
     if server is None:
-        return False, "Could not find the server."
+        return False, gettext("Could not find the server.")
 
     if server_data['instance'] == '' or\
             not server_data['instance']['status']:
@@ -341,11 +188,17 @@ def update_server(data):
         _server['status'] = False
     else:
         _server['status'] = True
-        clear_aws_session()
+        clear_cloud_session()
 
     return True, _server
 
 
+def clear_cloud_session():
+    """Clear cloud sessions."""
+    clear_aws_session()
+    clear_biganimal_session()
+
+
 @blueprint.route(
     '/update_cloud_process/<sid>', methods=['GET'],
     endpoint='update_cloud_process'
@@ -386,37 +239,3 @@ def update_cloud_server():
             'label': server.name
         }}
     )
-
-
-class CloudProcessDesc(IProcessDesc):
-    """Cloud Server Process Description."""
-    def __init__(self, _sid, _cmd, _provider, _instance_name):
-        self.sid = _sid
-        self.cmd = _cmd
-        self.instance_name = _instance_name
-        self.provider = 'Amazon RDS'
-
-        if _provider == 'rds':
-            self.provider = 'Amazon RDS'
-        elif _provider == 'azure':
-            self.provider = 'Azure PostgreSQL'
-        else:
-            self.provider = 'EDB Big Animal'
-
-    @property
-    def message(self):
-        return "Deployment on {0} is started for instance {1}.".format(
-            self.provider, self.instance_name)
-
-    def details(self, cmd, args):
-        res = '<div>' + self.message
-        res += '</div><div class="py-1">'
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(self.cmd)
-        res += '</div></div>'
-
-        return res
-
-    @property
-    def type_desc(self):
-        return "Cloud Deployment"
